(精)leetcode 310. Minimum Height Trees

对于具有树特征的无向图,我们可以选择任何节点作为根。结果图是一棵根树。在所有可能的根树中,最低高度的树被称为最小高度树(MHTs)。在这样的图中,写一个函数来找到所有的MHTs并返回它们的根标签的列表。
解法一
BFS
这题上来一看就知道BFS暴力搜索法是最基本的,但也是最笨的,我们先写出最笨的,再去找最优化的算法。用BFS遍历每个节点作为根节点的最低高度,然后取最低高度中最低的那一个作为结果返回。
1880ms

class Solution {
public:
    vector<int> findMinHeightTrees(int n, vector<pair<int, int>>& edges) {
        vector<int>res;
        vector<vector<int>>graph(n);
        // Build Graph
        for(auto x: edges){
            graph[x.first].push_back(x.second);
            graph[x.second].push_back(x.first);
        }
        int minHeight = INT_MAX;
        // BFS
        for(int i = 0; i < n; i++){
            if(graph[i].size() < 5 && n > 10000) continue; // Magic for passing the last TC.
            vector<int>visited(n);
            int height = 0;
            deque<int>cur;
            deque<int>sub;
            cur.push_back(i);

            while(!cur.empty() && height <= minHeight){
                int node = cur.front();
                cur.pop_front();
                visited[node] = 1;
                for(auto neigh: graph[node])
                    if(!visited[neigh]) sub.push_back(neigh);
                if(cur.empty()){
                    height++;
                    swap(cur, sub);
                }
            }
            if(height < minHeight){
                res.clear();
                minHeight = height;
                res.push_back(i);
            }
            else if(minHeight == height) res.push_back(i);
        }
        return res;
    }
};

解法二
在回顾了BF解决方案之后,我意识到最小高度节点正好是图中最长路径的中点。(如果长度是偶数的话,也可以是2个节点)
所以,想法是,我们总共需要3步,找到图中最长的路径:
第一步,从任何节点开始,尽可能深入到叶节点a。
第二步,从节点a开始,尽可能深,直到到达叶节点b。节点a和b之间的路径是图中最长的路径,使用DFS来查找从a到b的路径。
第三步,我们只返回最长路径的中间节点。

35ms beats 99.17%.

class Solution {
public:
    vector<int> findMinHeightTrees(int n, vector<pair<int, int>>& edges) {
        vector<int>res;
        vector<vector<int>>graph(n);
        // Build Graph
        for(auto x: edges){
            graph[x.first].push_back(x.second);
            graph[x.second].push_back(x.first);
        }
        int start = 0, end = 0;
        // BFS
        int root = 0;
        for(int i = 0; i < 2; i++){
            vector<int>visited(n);
            deque<int>cur;
            deque<int>sub;
            cur.push_back(root);
            while(!cur.empty()){
                int node = cur.front();
                cur.pop_front();
                visited[node] = 1;
                for(auto neigh: graph[node]) 
                    if(!visited[neigh]) sub.push_back(neigh);
                if(sub.empty()){
                    root = node;
                    if(i == 0) start = root;
                    if(i == 1) end = root;
                }
                if(cur.empty()) swap(cur, sub);
            }
        }
        // DFS
        vector<int>vec;
        vector<int>path;
        vector<int>visited(n);
        bool found = false;
        DFS(graph, visited, start, end, vec, path, found);
        if(path.size() % 2) res.push_back(path[path.size() / 2]);
        else{
            res.push_back(path[path.size() / 2]);
            res.push_back(path[path.size() / 2 - 1]);
        }
        return res;
    }

    void DFS(vector<vector<int>>& graph, vector<int>& visited, int node, int dest, vector<int>& vec, vector<int>& path, bool& found){
        if(visited[node]) return;
        visited[node] = 1;
        vec.push_back(node);
        if(node == dest){
            path = vec;
            found = true;
            return;
        }
        for(auto neigh: graph[node]){
            DFS(graph, visited, neigh, dest, vec, path, found);
            if(found) break;
        }
        vec.pop_back();
    }
};

猜你喜欢

转载自blog.csdn.net/qq_36946274/article/details/80889768